import nltk, re, pprint

sent = ['I', 'am', 'the', 'Walrus']
i = 0
while i < len(sent):
    print sent[i].lower(),
    i += 1

sent = ['I', 'am', 'the', 'Walrus']
for s in sent:
    print s.lower(),

word1 = 'Monty'
word2 = word1              # [_assignment1]
word1 = 'Python'           # [_assignment2]
word2

list1 = ['Monty', 'Python']
list2 = list1             # [_assignment3]
list1[1] = 'Bodkin'       # [_assignment4]
list2

text = 'I turned off the spectroroute'
words = ['I', 'turned', 'off', 'the', 'spectroroute']
pair = (6, 'turned')
text[2], words[3], pair[1]

len(text), len(words), len(pair)

words[2], words[3], words[4] = words[3], words[4], words[2]
words    

tmp = words[2]
words[2] = words[3]
words[3] = words[4]
words[4] = tmp

words = ['I', 'turned', 'off', 'the', 'spectroroute']
tags = ['NNP', 'VBD', 'IN', 'DT', 'NN']
zip(words, tags)

list(enumerate(words))

words = 'I turned off the spectroroute'.split()     # [_sequence1]
wordlens = [(len(word), word) for word in words]    # [_sequence2]
wordlens

wordlens.sort()                                     # [_sequence3]
' '.join([word for (count, word) in wordlens])      # [_sequence4]

lexicon = [
    ('the', 'DT', ['Di:', 'D@']),
    ('off', 'IN', ['Qf', 'O:f'])
]

lexicon.sort()
lexicon[1] = ('turned', 'VBD', ['t3:nd', 't3`nd'])
del lexicon[0]

phrase = "( the cat ) ( sat ( on ( the mat )"
print check_parens(phrase.split())

phrase = "( the cat ) ( sat ( on ( the mat ) ) )"
print convert_parens(phrase.split())

queue = ['the', 'cat', 'sat']
queue.append('on')
queue.append('the')
queue.append('mat')
queue.pop(0)

queue.pop(0)

queue

sent = ['The', 'dog', 'gave', 'John', 'the', 'newspaper']
[word.lower() for word in sent]

sent = ['The', 'dog', 'gave', 'John', 'the', 'newspaper']
n = 3
[sent[i:i+n] for i in range(len(sent)-n+1)]

[(dt,jj,nn) for dt in ('two', 'three')
            for jj in ('old', 'blind')
            for nn in ('men', 'mice')]

[word for word in nltk.corpus.brown.words(categories='a')
    if len(word) == 17]

m, n = 3, 7
array = [[set() for i in range(n)] for j in range(m)]     # [_2d-array]
array[2][5].add('foo')
pprint.pprint(array)

from numpy import average
average([len(word) for word in nltk.corpus.brown.words(categories='a')])

entry_tuple = ('turned', 'VBD', ['t3:nd', 't3`nd'])
entry_tuple[1]

entry_dict = {'lexeme':'turned', 'pos':'VBD', 'pron':['t3:nd', 't3`nd']}
entry_dict['pos']

LEXEME = 0; POS = 1; PRON = 2
entry_tuple[POS]

words = nltk.corpus.words.words()
print mystery(words)                         # doctest: +SKIP

word = 'cat'
sentence = """hello
world"""
print word

print sentence

word

sentence

wordcount = {'cat':3, 'dog':4, 'snake':1}
for word in sorted(wordcount):
    print word, '->', wordcount[word], ';',

for word in sorted(wordcount):
   print '%s->%d;' % (word, wordcount[word]),

'%6s' % 'dog'

'%-6s' % 'dog'

width = 6
'%-*s' % (width, 'dog')

"accuracy for %d words: %2.4f%%" % (9375, 100.0 * 3205/9375)

genres = ['a', 'd', 'e', 'h', 'n']
cfdist = count_words_by_tag('MD', genres)
modals = ['can', 'could', 'may', 'might', 'must', 'will']   # [_modals-of-interest]
tabulate(cfdist, modals)

concordance('line', 32)

file = open('output.txt', 'w')
words = set(nltk.corpus.genesis.words('english-kjv.txt'))
for word in sorted(words):
    file.write(word + "\n")

len(words)

`len(words)`

file.write(`len(words)` + "\n")
file.close()

genres = ['a', 'd', 'e', 'h', 'n']
cfdist = count_words_by_tag('MD', genres)
modals = ['can', 'could', 'may', 'might', 'must', 'will']
counts = {}
for genre in genres:
    counts[genre] = [cfdist[genre][word] for word in modals]
bar_chart(genres, modals, counts)

help(get_text)

tag('the')

tag('dog')

tag({'lexeme':'turned', 'pos':'VBD', 'pron':['t3:nd', 't3`nd']})

def tag(word):
    result = 'NN'                       # default value, a string
    if word in ['a', 'the', 'all']:     # in certain cases...
        result = 'DT'                   #   overwrite the value
    return result                       # all paths end here

def proc_words(words):
    avg_wordlen = sum(len(word) for word in words)/len(words)
    chars_used = ''.join(sorted(set(''.join(words))))
    return avg_wordlen, chars_used
proc_words(['Not', 'a', 'good', 'way', 'to', 'write', 'functions'])

def my_sort1(l):      # good: modifies its argument, no return value
    l.sort()
def my_sort2(l):      # good: doesn't touch its argument, returns value
    return sorted(l)
def my_sort3(l):      # bad: modifies its argument and also returns it
    l.sort()
    return l

w = ''
p = {}
set_up(w, p)
w

p

w = ''
word = w
word = 'cat'
w

p = {}
properties = p
properties['pos'] = 'noun'
p

data = load_corpus()
results = analyze(data)
present(results)

constitution = "http://www.archives.gov/national-archives-experience/charters/constitution_transcript.html"
fd = nltk.FreqDist()
freq_words(constitution, fd, 20)

fd = freq_words(constitution)
print fd.sorted()[:20]

words = nltk.wordpunct_tokenize(nltk.clean_url(constitution))
fd = nltk.FreqDist(word.lower() for word in words)
fd.sorted()[:20]

def extract_property(prop):
    words = ['The', 'dog', 'gave', 'John', 'the', 'newspaper']
    return [prop(word) for word in words]
extract_property(len)

def last_letter(word):
    return word[-1]
extract_property(last_letter)

extract_property(lambda w: w[-1])

words = 'I turned off the spectroroute'.split()
sorted(words)

sorted(words, cmp)

sorted(words, lambda x, y: cmp(len(y), len(x)))

def is_lexical(word):
    return word.lower() not in ('a', 'an', 'the', 'that', 'to')
sent = ['The', 'dog', 'gave', 'John', 'the', 'newspaper']
filter(is_lexical, sent)

average(map(len, nltk.corpus.brown.sents(categories='a')))

sent = ['The', 'dog', 'gave', 'John', 'the', 'newspaper']
def is_vowel(letter):
    return letter in "AEIOUaeiou"
def vowelcount(word):
    return len(filter(is_vowel, word))
map(vowelcount, sent)

map(lambda w: len(filter(lambda c: c in "AEIOUaeiou", w)), sent)

duplicates(['cat', 'dog', 'cat', 'pig', 'dog', 'cat', 'ant', 'cat'])

def factorial(n):
    result = 1
    for i in range(n):
        result *= (i+1)
    return result

def factorial(n):
    if n == 1:
        return n
    else:
        return n * factorial(n-1)

def perms(seq):
    if len(seq) <= 1:
        yield seq
    else:
        for perm in perms(seq[1:]):
            for i in range(len(perm)+1):
                yield perm[:i] + seq[0:1] + perm[i:]
list(perms(['police', 'fish', 'cream']))

trie = {}
insert(trie, 'chat', 'cat')
insert(trie, 'chien', 'dog')
trie['c']['h']

trie['c']['h']['a']['t']['value']

pprint.pprint(trie)

virahanka1(4)

virahanka2(4)

virahanka3(4)

virahanka4(4)

from timeit import Timer
Timer("PYTHON CODE", "INITIALIZATION CODE").timeit()

